//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers    2
#property indicator_color1     LimeGreen
#property indicator_color2     Red
#property indicator_width1     2
#property indicator_width2     2
#property indicator_level1     0
#property strict

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame         = PERIOD_CURRENT; // Time frame to use
extern double          BoxPeriod         = 6.5;            // XO box size in pips
extern bool            XOcleanForHA_On   = TRUE;           // Use HA close for price
extern ENUM_MA_METHOD  haMaMetod         = MODE_SMMA;      // HA smoothed ma method 1
extern int             haMaPeriod        = 6;              // HA smoothed ma period 1
extern ENUM_MA_METHOD  haMaMetod2        = MODE_LWMA;      // HA smoothed ma method 2 
extern int             haMaPeriod2       = 2;              // HA smoothed ma period 2
extern bool            alertsOn          = true;           // Turn alerts on
extern bool            alertsOnCurrent   = false;          // Alerts on current (still opened) bar
extern bool            alertsMessage     = true;           // Alerts should show popup message
extern bool            alertsSound       = true;           // Alerts should play alert sound
extern bool            alertsNotify      = false;          // Alerts should send notification
extern bool            alertsEmail       = false;          // Alerts should send email
extern bool            ShowLines         = true;           // Show line
extern bool            LinesOnFirst      = true;           // Lines on first bar of higher time frame
extern string          LinesIdentifier   = "XOLines1";     // Lines unique ID
extern color           LinesColorForUp   = clrLimeGreen;   // Lines up color
extern color           LinesColorForDown = clrRed;         // Lines down color
extern ENUM_LINE_STYLE LinesStyle        = STYLE_DOT;      // Lines style

//
//
//
//
//

double Hi[];
double Lo[];
double no[];
double kr[];
double trend[];

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];

string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------

int init()
{  
   IndicatorBuffers(8);   
      SetIndexBuffer(0,kr); SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexEmptyValue(0,0); SetIndexLabel(0,"XO Up");
      SetIndexBuffer(1,no); SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexEmptyValue(1,0); SetIndexLabel(1,"XO Down");
      SetIndexBuffer(2,Hi);
      SetIndexBuffer(3,Lo);
      SetIndexBuffer(4,trend);
      SetIndexBuffer(5,ExtMapBuffer1);
      SetIndexBuffer(6,ExtMapBuffer2);
      SetIndexBuffer(7,ExtMapBuffer3);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame==-99);
         TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" XO ("+(string)BoxPeriod+")");
   return(0);
}


//
//
//
//
//

int deinit()
{
   int lookForLength = StringLen(LinesIdentifier);
   for (int i=ObjectsTotal(); i>=0; i--)
      {
         string name = ObjectName(i);
         if (StringSubstr(name,0,lookForLength)==LinesIdentifier) ObjectDelete(name);
      }
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-2);
           if (returnBars) { kr[0] = limit+1; return(0); }
         
   //
   //
   //
   //
   //
    
   if (TimeFrame == Period())
   {
      double pipMultiplier = 1; if(Digits==3 || Digits==5) pipMultiplier = 10;
      for(int i=limit; i>=0; i--)
      {
         double maOpen  = iMA(NULL,0,haMaPeriod,0,haMaMetod,PRICE_OPEN ,i);
         double maClose = iMA(NULL,0,haMaPeriod,0,haMaMetod,PRICE_CLOSE,i);
         double maLow   = iMA(NULL,0,haMaPeriod,0,haMaMetod,PRICE_LOW  ,i);
         double maHigh  = iMA(NULL,0,haMaPeriod,0,haMaMetod,PRICE_HIGH ,i);
       
         double haOpen=(ExtMapBuffer2[i+1]+ExtMapBuffer3[i+1])/2;
         double haClose=(maOpen+maHigh+maLow+maClose)/4;
       
              ExtMapBuffer2[i]=haOpen;
              ExtMapBuffer3[i]=haClose;
      }
      for(int i=limit; i>=0; i--)
      {
         ExtMapBuffer1[i]=iMAOnArray(ExtMapBuffer3,Bars,haMaPeriod2,0,haMaMetod2,i);
         double xoClose = Close[i];
         if (XOcleanForHA_On) xoClose = ExtMapBuffer1[i];
         if (i>=(Bars-2)) { Hi[i+1]=xoClose; Lo[i+1]=xoClose; continue; }
           double cur      = xoClose;
                  Hi[i]    = Hi[i+1];
                  Lo[i]    = Lo[i+1];
                  no[i]    = no[i+1];
                  kr[i]    = kr[i+1];
                  trend[i] = trend[i+1];

                  if (cur > (Hi[i]+BoxPeriod*Point*pipMultiplier)) 
                  {
                       Hi[i]    = cur;
                       Lo[i]    = cur-BoxPeriod*Point*pipMultiplier;
                       kr[i]    = kr[i+1]+1;
                       no[i]    = 0;
                       trend[i] = 1;
                  }
                  if (cur < (Lo[i]-BoxPeriod*Point*pipMultiplier)) 
                  {
                       Lo[i]    = cur;
                       Hi[i]    = cur+BoxPeriod*Point*pipMultiplier;
                       no[i]    = no[i+1]-1;
                       kr[i]    = 0;
                       trend[i] = -1;
                  }
                  if (ShowLines)
                  {
                    ObjectDelete(LinesIdentifier+":"+(string)Time[i]);
                       if (trend[i]!=trend[i+1])
                       if (trend[i]==1)
                             drawLine(i,LinesColorForUp);
                       else  drawLine(i,LinesColorForDown);
                  } 
      }                 
      manageAlerts();
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (int i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         kr[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,BoxPeriod,XOcleanForHA_On,haMaMetod,haMaPeriod,haMaMetod2,haMaPeriod2,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,ShowLines,LinesOnFirst,LinesIdentifier,LinesColorForUp,LinesColorForDown,LinesStyle,0,y);
         no[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,BoxPeriod,XOcleanForHA_On,haMaMetod,haMaPeriod,haMaMetod2,haMaPeriod2,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,ShowLines,LinesOnFirst,LinesIdentifier,LinesColorForUp,LinesColorForDown,LinesStyle,1,y);
         trend[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,BoxPeriod,XOcleanForHA_On,haMaMetod,haMaPeriod,haMaMetod2,haMaPeriod2,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,ShowLines,LinesOnFirst,LinesIdentifier,LinesColorForUp,LinesColorForDown,LinesStyle,4,y);
   }
   return(0);         
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(timeFrameToString(_Period)+" "+Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," XO for HA trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"XO for HA"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void drawLine(int i, color theColor)
{
   string name = LinesIdentifier+":"+(string)Time[i]; 
   int adt = 0; if (!LinesOnFirst) adt = _Period*60-1;
   ObjectCreate(name,OBJ_VLINE,0,Time[i]+adt,0);
      ObjectSet(name,OBJPROP_COLOR,theColor);
      ObjectSet(name,OBJPROP_BACK,true);
      ObjectSet(name,OBJPROP_STYLE,LinesStyle);
}